---------------------------------------------------------------------
--                      Open_Image - TIFF_IO
--
--                     Copyright (C) 2000
--                     Jeffrey Creem
--
-- This library is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public
-- License as published by the Free Software Foundation; either
-- version 2 of the License, or (at your option) any later version.
--
-- This library is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for more details.
--
-- You should have received a copy of the GNU General Public
-- License along with this library; if not, write to the
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,
-- Boston, MA 02111-1307, USA.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this  unit  does not  by itself cause  the resulting
-- executable to be covered by the GNU General Public License. This
-- exception does not however invalidate any other reasons why the
-- executable file  might be covered by the  GNU Public License.
---------------------------------------------------------------------

--  <description>
--
--  This package allows for the input and output of images files
--  stored in the TIFF format. All code is based on the TIFF Revision
--  6.0 specification dataed June 3, 1992.
--
--  </description>
--
with Open_Image;

package body Open_Image.TIFF_IO is

  type Byte_Order_Type is private;

  Little_Endian_Order : constant Byte_Order_Type;
  Big_Endian_Order    : constant Byte_Order_Type;


  type Image_File_Header_Type is
  record
    Byte_Order                  : Byte_Order_Type;
    TIFF_Magic_Number           : TIFF_Magic_Number_Type;
    Image_File_Directory_Offset : Something;
  end record;


  procedure Read_TIFF;


  -----------------------------------------------------------------------------
  --
  -- PROCEDURE  : Is_A_TIFF_File
  --
  -- PURPOSE    : Checks the contents of the file to determine if it is PPM
  --              file.
  --
  -- NOTES      : At the moment this just checks the "magic number" information
  --              in the file header.
  --
  -----------------------------------------------------------------------------
  function Is_A_TIFF_File (
        Name : in     String )
    return Boolean is

  begin
    null;

  end Is_A_TIFF_File;


end Open_Image.TIFF_IO;
